<!DOCTYPE html>
<html lang="en">

<head>
  <title>Bootstrap Example</title>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
  <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.16.0/umd/popper.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>



<body onload="onPageLoading()">
  <div class="container">
    <p class="h3 text-center mt-5">Order Details!!!</p>
    <div class="row form-group">
      <div class="col-2 text-right">
        <label>Order Code</label>
      </div>
      <div class="col-4">
        <input class="form-control" id="inp-ordercode">
      </div>
      <div class="col-2 text-right">
        <label>Cỡ Combo:</label>
      </div>
      <div class="col-4">
        <select id="select-size" class="form-control">
          <option value="NOT_SELECT_COMBO">Chọn cỡ Combo (Combo size)</option>
          <option value="S">Nhỏ</option>
          <option value="M">Vừa</option>
          <option value="L">Lớn</option>
        </select>
      </div>
    </div>
    <div class="row form-group">
      <div class="col-2 text-right">
        <label>Đường kính Pizza</label>
      </div>
      <div class="col-4">
        <input class="form-control" id="inp-duong-kinh">
      </div>
      <div class="col-2 text-right">
        <label>Sườn nướng (miếng)</label>
      </div>
      <div class="col-4">
        <input class="form-control" id="inp-suong-nuong">
      </div>
    </div>
    <div class="row form-group">
      <div class="col-2 text-right">
        <label>Đồ uống</label>
      </div>
      <div class="col-4">
        <select class="form-control" id="select-drink">
          <option value="NOT_SELECT_DRINK">Chọn đồ uống</option>
        </select>
      </div>
      <div class="col-2 text-right">
        <label>Số lượng nước uống</label>
      </div>
      <div class="col-4">
        <input class="form-control" id="inp-number">
      </div>
    </div>
    <div class="row form-group">
      <div class="col-2 text-right">
        <label>Voucher ID</label>
      </div>
      <div class="col-4">
        <input class="form-control" id="inp-voucherid">
      </div>
      <div class="col-2 text-right">
        <label>Loại pizza</label>
      </div>
      <div class="col-4">
        <select id="select-pizza" class="form-control">
          <option value="NOT_SELECT_PIZZA">Chọn loại pizza</option>
          <option value="Seafood">Hải sản</option>
          <option value="Hawaii">Ha wai</option>
          <option value="Bacon">Thịt hun khói</option>
        </select>
      </div>
    </div>
    <div class="row form-group">
      <div class="col-2 text-right">
        <label>Salad</label>
      </div>
      <div class="col-4">
        <input class="form-control" id="inp-salad">
      </div>
      <div class="col-2 text-right">
        <label>Thành tiền</label>
      </div>
      <div class="col-4">
        <input class="form-control" id="inp-eprices">
      </div>
    </div>
    <div class="row form-group">
      <div class="col-2 text-right">
        <label>Giảm giá</label>
      </div>
      <div class="col-4">
        <input class="form-control" id="inp-giam-gia">
      </div>
      <div class="col-2 text-right">
        <label>Họ và tên</label>
      </div>
      <div class="col-4">
        <input class="form-control" id="inp-efullname">
      </div>
    </div>
    <div class="row form-group">
      <div class="col-2 text-right">
        <label>Email</label>
      </div>
      <div class="col-4">
        <input class="form-control" id="inp-email">
      </div>
      <div class="col-2 text-right">
        <label>Số điện thoại</label>
      </div>
      <div class="col-4">
        <input class="form-control" id="inp-mobile">
      </div>
    </div>
    <div class="row form-group">
      <div class="col-2 text-right">
        <label>Địa chỉ</label>
      </div>
      <div class="col-4">
        <input class="form-control" id="inp-address">
      </div>
      <div class="col-2 text-right">
        <label>Lời nhắn</label>
      </div>
      <div class="col-4">
        <input class="form-control" id="inp-message">
      </div>
    </div>
    <div class="row form-group">
      <div class="col-2 text-right">
        <label>Trạng thái đơn hàng</label>
      </div>
      <div class="col-4">
        <select id="select-status" class="form-control">
          <option value="NOT_SELECT_STATUS">Trạng thái</option>
          <option value="open">Open</option>
          <option value="confirmed">Confirm</option>
          <option value="cancel">Cancel</option>
        </select>
      </div>
      <div class="col-2 text-right">
        <label>Ngày tạo đơn</label>
      </div>
      <div class="col-4">
        <input class="form-control" id="inp-create-order">
      </div>
    </div>
    <div class="row form-group">
      <div class="col-2 text-right">
        <label>Ngày cập nhật</label>
      </div>
      <div class="col-4">
        <input class="form-control" id="inp-update">
      </div>
    </div>
    <div class="row form-group">
      <div class="col-2 text-right">
      </div>
      <div class="col-4">
        <button class="btn btn-group btn-success" id="btn-confirm">Confirm</button>
        <button class="btn btn-group btn-info" id="btn-cancel">Cancel</button>
      </div>
    </div>
  </div>
</body>
<script>
  "use strict";

  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC ***/
  const gREQUEST_STATUS_OK = 200;
  const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
  const gREQUEST_CREATE_SUCCESS = 201; // tạo thành công
  const gREQUEST_DELETE_SUCCESS = 204; // xóa thành công
  const gBASE_URL_Order = "http://203.171.20.210:8080/devcamp-pizza365/orders";
  const gBASE_URL_Drinks = "http://203.171.20.210:8080/devcamp-pizza365/drinks";

  /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements ***/
  var vURLString = window.location.href;
  var vURL = new URL(vURLString);
  var gId = vURL.searchParams.get('id');
  var gOrder = vURL.searchParams.get('orderCode');

  /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện ***/
  function onPageLoading() {
    //base url
    const vBASE_URL = "http://203.171.20.210:8080/devcamp-pizza365/orders/" + gOrder;
    var vXmlHttpGetOrderById = new XMLHttpRequest();
    vXmlHttpGetOrderById.open("GET", vBASE_URL, true);
    vXmlHttpGetOrderById.onreadystatechange = function () {
      if (this.readyState === gREQUEST_READY_STATUS_FINISH_AND_OK && this.status === gREQUEST_STATUS_OK) {
        showDataOrder(JSON.parse(this.responseText));
      }
    };
    vXmlHttpGetOrderById.send();
  }
  document.getElementById('btn-confirm').addEventListener('click', function () {
    printOrderId(gId);
    updateOrderStatus(gId, 'confirmed');
  });

  document.getElementById('btn-cancel').addEventListener('click', function () {
    printOrderId(gId);
    updateOrderStatus(gId, 'cancel');
  });


  /*** REGION 4 - Common functions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình***/
  function showDataOrder(paramOrder) {
    var vOrderCode = document.getElementById("inp-ordercode");
    var vCombo = document.getElementById("select-size");
    var vDuongKinhPizza = document.getElementById("inp-duong-kinh");
    var vSuongNuong = document.getElementById("inp-suong-nuong");
    var vDrinks = document.getElementById("select-drink");
    var vSLNuocUong = document.getElementById("inp-number");
    var vVoucherID = document.getElementById("inp-voucherid");
    var vPizzaType = document.getElementById("select-pizza");
    var vSalad = document.getElementById("inp-salad");
    var vThanhTien = document.getElementById("inp-eprices");
    var vDiscount = document.getElementById("inp-giam-gia");
    var vFullName = document.getElementById("inp-efullname");
    var vEmail = document.getElementById("inp-email");
    var vSoDienThoai = document.getElementById("inp-mobile");
    var vDiaChi = document.getElementById("inp-address");
    var vLoiNhan = document.getElementById("inp-message");
    var vStatus = document.getElementById("select-status");
    var vTaoDonHang = document.getElementById("inp-create-order");
    var vUpdate = document.getElementById("inp-update");

    // Gán giá trị cho từng form
    vOrderCode.value = paramOrder.orderCode;
    vCombo.value = paramOrder.kichCo;
    vDuongKinhPizza.value = paramOrder.duongKinh;
    vSuongNuong.value = paramOrder.suon;
    vDrinks.value = paramOrder.idLoaiNuocUong;
    vSLNuocUong.value = paramOrder.soLuongNuocUong;
    vVoucherID.value = paramOrder.voucherID;
    vPizzaType.value = paramOrder.idLoaiPizza;
    vSalad.value = paramOrder.salad;
    vThanhTien.value = paramOrder.thanhTien;
    vDiscount.value = paramOrder.giamGia;
    vFullName.value = paramOrder.hoTen;
    vEmail.value = paramOrder.email;
    vSoDienThoai.value = paramOrder.soDienThoai;
    vDiaChi.value = paramOrder.diaChi;
    vLoiNhan.value = paramOrder.loiNhan;
    vStatus.value = paramOrder.trangThai;

    // Disable/enable các trường và nút tương ứng
    if (vStatus.value !== "0") {
      vTaoDonHang.disabled = true;
      vUpdate.disabled = true;
      vCombo.disabled = true;
      vDuongKinhPizza.disabled = true;
      vSuongNuong.disabled = true;
      vDrinks.disabled = true;
      vSLNuocUong.disabled = true;
      vVoucherID.disabled = true;
      vPizzaType.disabled = true;
      vSalad.disabled = true;
      vFullName.disabled = true;
      vEmail.disabled = true;
      vSoDienThoai.disabled = true;
      vDiaChi.disabled = true;
      vLoiNhan.disabled = true;
      vStatus.disabled = true;
    } else {
      vTaoDonHang.disabled = true;
      vUpdate.disabled = false;
      vCombo.disabled = false;
      vDuongKinhPizza.disabled = false;
      vSuongNuong.disabled = false;
      vDrinks.disabled = false;
      vSLNuocUong.disabled = false;
      vVoucherID.disabled = false;
      vPizzaType.disabled = false;
      vSalad.disabled = false;
      vFullName.disabled = false;
      vEmail.disabled = false;
      vSoDienThoai.disabled = false;
      vDiaChi.disabled = false;
      vLoiNhan.disabled = false;
      vStatus.disabled = false;
    }
  }

  function printOrderId(orderId) {
    console.log(orderId);
  }
  function updateOrderStatus(orderId, status) {
    const updateUrl = `http://203.171.20.210:8080/devcamp-pizza365/orders/${orderId}`;

    const updateRequest = new XMLHttpRequest();
    updateRequest.open('PUT', updateUrl, true);
    updateRequest.setRequestHeader('Content-Type', 'application/json');

    updateRequest.onreadystatechange = function () {
      if (updateRequest.readyState === gREQUEST_READY_STATUS_FINISH_AND_OK) {
        console.log(updateRequest.responseText);
      }
    };

    const data = {
      trangThai: status
    };

    updateRequest.send(JSON.stringify(data));
  }


</script>


</html>